; $Id: grepindave.pro,v 1.2 2012/06/07 15:52:26 kneller Exp $
;
;Find locations of string s in the dave source code.
;
;
pro grepInDave,s,fn=fn,output=output,davedir=davedir,fullpath=fullpath
  if n_elements(fullpath) eq 0 then fullpath = 0

  cd,current=current
  ;davedir = 'C:\Users\kneller\Desktop\dave_clean_073010\dave_devel\dave\programs\'
  if n_elements(davedir) eq 0 then begin
    davedir = dialog_pickfile(path = '.', /directory,title='Choose DAVE Source Directory:')
  endif

  if file_test(davedir,/directory) ne 0 then begin
  
    if n_elements(fn) eq 0 then begin
      duh = ls_descend(filter='*.pro',dir=davedir)
      fn = duh
    endif
    if n_elements(fn) eq 0 then begin
      print,'No .pro files found in '+davedir
      return
    endif
    duh = fn
    grep,duh,s,/i,/exclusive,/l,output=output,fullpath=fullpath
  endif else begin
    print,'Directory does not exist.'
  endelse
  cd,current

end;grepInDave
