; $Id: macs_get_a12345_int.pro,v 1.6 2010/04/23 21:33:58 kneller Exp $

pro macs_get_a12345_int,macsptr,a1,a2,a3,a4,a5,a6,spec,diff,counttime=counttime,monitor=monitor,weights=weights,$
                        specweights=specweights,diffweights=diffweights,$   ;LRK - 04/12/10  ADDING THESE KEYWORDS B/C I BELIEVE WEIGHTS
                                                                            ;                ARE NOT APPLIED PROPERLY
                        mask_det=mask_det,a4_pos=a4_pos,a3_mask=a3_mask,a4_mask=a4_mask
help,/traceback
;LRK - 04/12/10
;REPLACE THIS BLOCK WITH THE ONE BELOW IT
;if n_elements(weights) eq 0 then begin
;   weights=[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
;endif
if n_elements(weights) eq 0 then begin
   weights=fltarr(20)+1.0
endif
if n_elements(specweights) eq 0 then begin
   print,'macs_get_a12345_int --- NO SPECTROSCOPIC WEIGHTS, setting to "WEIGHTS" value '
   specweights=weights
endif
if n_elements(diffweights) eq 0 then begin
   print,'macs_get_a12345_int --- NO DIFFRACTION WEIGHTS, setting to "WEIGHTS" value '
   diffweights=weights
endif


if n_elements(a4_pos) eq 0 then begin
a4_pos=[-76.,-68.,-60.,-52.,-44.,-36.,-28.,-20.,-12.,-4.,4.,12.,20.,28.,36.,44.,52.,60.,68.,76.]
endif

kp=a4_pos


a1 = float([(*macsptr.a1),(*macsptr.a1),(*macsptr.a1),(*macsptr.a1),(*macsptr.a1) $
     ,(*macsptr.a1),(*macsptr.a1),(*macsptr.a1),(*macsptr.a1),(*macsptr.a1) $
     ,(*macsptr.a1),(*macsptr.a1),(*macsptr.a1),(*macsptr.a1),(*macsptr.a1) $
     ,(*macsptr.a1),(*macsptr.a1),(*macsptr.a1),(*macsptr.a1),(*macsptr.a1)])
    
     
a2 = float([(*macsptr.a2),(*macsptr.a2),(*macsptr.a2),(*macsptr.a2),(*macsptr.a2) $
     ,(*macsptr.a2),(*macsptr.a2),(*macsptr.a2),(*macsptr.a2),(*macsptr.a2) $
     ,(*macsptr.a2),(*macsptr.a2),(*macsptr.a2),(*macsptr.a2),(*macsptr.a2) $
     ,(*macsptr.a2),(*macsptr.a2),(*macsptr.a2),(*macsptr.a2),(*macsptr.a2) ])
     
     
a3 = float([(*macsptr.a3),(*macsptr.a3),(*macsptr.a3),(*macsptr.a3),(*macsptr.a3) $
     ,(*macsptr.a3),(*macsptr.a3),(*macsptr.a3),(*macsptr.a3),(*macsptr.a3) $
     ,(*macsptr.a3),(*macsptr.a3),(*macsptr.a3),(*macsptr.a3),(*macsptr.a3) $
     ,(*macsptr.a3),(*macsptr.a3),(*macsptr.a3),(*macsptr.a3),(*macsptr.a3) ])
     
     
a4 = float([(*macsptr.kidney) + kp[0] $
     ,(*macsptr.kidney)  + kp[1] $
     ,(*macsptr.kidney)  + kp[2] $
     ,(*macsptr.kidney)  + kp[3] $
     ,(*macsptr.kidney)  + kp[4] $
     ,(*macsptr.kidney)  + kp[5] $
     ,(*macsptr.kidney)  + kp[6] $
     ,(*macsptr.kidney)  + kp[7] $
     ,(*macsptr.kidney)  + kp[8] $     
     ,(*macsptr.kidney)  + kp[9] $
     ,(*macsptr.kidney)  + kp[10] $
     ,(*macsptr.kidney)  + kp[11] $
     ,(*macsptr.kidney)  + kp[12] $
     ,(*macsptr.kidney)  + kp[13] $
     ,(*macsptr.kidney)  + kp[14] $
     ,(*macsptr.kidney)  + kp[15] $
     ,(*macsptr.kidney)  + kp[16] $
     ,(*macsptr.kidney)  + kp[17] $
     ,(*macsptr.kidney)  + kp[18] $
     ,(*macsptr.kidney)   + kp[19]  ])




a5 = float([(*macsptr.analyzertheta01)  $
     ,(*macsptr.analyzertheta02)  $
     ,(*macsptr.analyzertheta03)  $
     ,(*macsptr.analyzertheta04)  $
     ,(*macsptr.analyzertheta05)  $
     ,(*macsptr.analyzertheta06)  $
     ,(*macsptr.analyzertheta07)  $
     ,(*macsptr.analyzertheta08)  $
     ,(*macsptr.analyzertheta09)  $     
     ,(*macsptr.analyzertheta10)  $
     ,(*macsptr.analyzertheta11)  $
     ,(*macsptr.analyzertheta12)  $
     ,(*macsptr.analyzertheta13)  $
     ,(*macsptr.analyzertheta14)  $
     ,(*macsptr.analyzertheta15)  $
     ,(*macsptr.analyzertheta16)  $
     ,(*macsptr.analyzertheta17)  $
     ,(*macsptr.analyzertheta18)  $
     ,(*macsptr.analyzertheta19)  $
     ,(*macsptr.analyzertheta20)  ])
    
     
a6=2.*a5

;LRK - 04/12/10
;REPLACE THIS BLOCK WITH THE ONE BELOW IT
;spec =float( [(*macsptr.spec01)*weights[0]  $
;     ,(*macsptr.spec02)*weights[1]  $
;     ,(*macsptr.spec03)*weights[2]  $
;     ,(*macsptr.spec04)*weights[3]  $
;     ,(*macsptr.spec05)*weights[4]  $
;     ,(*macsptr.spec06)*weights[5]  $
;     ,(*macsptr.spec07)*weights[6]  $
;     ,(*macsptr.spec08)*weights[7]  $
;     ,(*macsptr.spec09)*weights[8]  $     
;     ,(*macsptr.spec10)*weights[9]  $
;     ,(*macsptr.spec11)*weights[10]  $
;     ,(*macsptr.spec12)*weights[11]  $
;     ,(*macsptr.spec13)*weights[12]  $
;     ,(*macsptr.spec14)*weights[13]  $
;     ,(*macsptr.spec15)*weights[14]  $
;     ,(*macsptr.spec16)*weights[15]  $
;     ,(*macsptr.spec17)*weights[16]  $
;     ,(*macsptr.spec18)*weights[17]  $
;     ,(*macsptr.spec19)*weights[18]  $
;     ,(*macsptr.spec20)*weights[19]  ])


spec =float( [(*macsptr.spec01)*specweights[0]  $
     ,(*macsptr.spec02)*specweights[1]  $
     ,(*macsptr.spec03)*specweights[2]  $
     ,(*macsptr.spec04)*specweights[3]  $
     ,(*macsptr.spec05)*specweights[4]  $
     ,(*macsptr.spec06)*specweights[5]  $
     ,(*macsptr.spec07)*specweights[6]  $
     ,(*macsptr.spec08)*specweights[7]  $
     ,(*macsptr.spec09)*specweights[8]  $     
     ,(*macsptr.spec10)*specweights[9]  $
     ,(*macsptr.spec11)*specweights[10]  $
     ,(*macsptr.spec12)*specweights[11]  $
     ,(*macsptr.spec13)*specweights[12]  $
     ,(*macsptr.spec14)*specweights[13]  $
     ,(*macsptr.spec15)*specweights[14]  $
     ,(*macsptr.spec16)*specweights[15]  $
     ,(*macsptr.spec17)*specweights[16]  $
     ,(*macsptr.spec18)*specweights[17]  $
     ,(*macsptr.spec19)*specweights[18]  $
     ,(*macsptr.spec20)*specweights[19]  ])



;LRK - 04/12/10
;REPLACE THIS BLOCK WITH THE ONE BELOW IT
;diff = float([(*macsptr.diff01)  $
;     ,(*macsptr.diff02)  $
;     ,(*macsptr.diff03)  $
;     ,(*macsptr.diff04)  $
;     ,(*macsptr.diff05)  $
;     ,(*macsptr.diff06)  $
;     ,(*macsptr.diff07)  $
;     ,(*macsptr.diff08)  $
;     ,(*macsptr.diff09)  $     
;     ,(*macsptr.diff10)  $
;     ,(*macsptr.diff11)  $
;     ,(*macsptr.diff12)  $
;     ,(*macsptr.diff13)  $
;     ,(*macsptr.diff14)  $
;     ,(*macsptr.diff15)  $
;     ,(*macsptr.diff16)  $
;     ,(*macsptr.diff17)  $
;     ,(*macsptr.diff18)  $
;     ,(*macsptr.diff19)  $
;     ,(*macsptr.diff20)  ]   )


diff = float([(*macsptr.diff01)*diffweights[0]  $
     ,(*macsptr.diff02)*diffweights[1]  $
     ,(*macsptr.diff03)*diffweights[2]  $
     ,(*macsptr.diff04)*diffweights[3]  $
     ,(*macsptr.diff05)*diffweights[4]  $
     ,(*macsptr.diff06)*diffweights[5]  $
     ,(*macsptr.diff07)*diffweights[6]  $
     ,(*macsptr.diff08)*diffweights[7]  $
     ,(*macsptr.diff09)*diffweights[8]  $
     ,(*macsptr.diff10)*diffweights[9]  $
     ,(*macsptr.diff11)*diffweights[10]  $
     ,(*macsptr.diff12)*diffweights[11]  $
     ,(*macsptr.diff13)*diffweights[12]  $
     ,(*macsptr.diff14)*diffweights[13]  $
     ,(*macsptr.diff15)*diffweights[14]  $
     ,(*macsptr.diff16)*diffweights[15]  $
     ,(*macsptr.diff17)*diffweights[16]  $
     ,(*macsptr.diff18)*diffweights[17]  $
     ,(*macsptr.diff19)*diffweights[18]  $
     ,(*macsptr.diff20)*diffweights[19]  ]   )
     

counttime = float([(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $     
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  $
     ,(*macsptr.time)  ])
      
 
 monitor= float([(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $     
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  $
     ,(*macsptr.monitor)  ]    )
      


if n_elements(mask_det) ne 0 then begin
    aa=(*macsptr.a1)*0
    mask=aa+mask_det[0]
    for nn=1,19 do begin
    mask=[mask,aa+mask_det[nn]]
    endfor
    ;help,mask
    nomask=where(mask eq 1)
    ;help,nomask
    a1=a1[nomask]
    a2=a2[nomask]
    a3=a3[nomask]
    a4=a4[nomask]
    a5=a5[nomask]
    a6=2.*a5
    spec=spec[nomask] 
    diff=diff[nomask]
    counttime=counttime[nomask] 
    monitor=monitor[nomask]
endif

if n_elements(a3_mask) eq 2 then begin
    nomask=where( (a3 lt a3_mask[0]) or (a3 gt a3_mask[1]))
    a1=a1[nomask]
    a2=a2[nomask]
    a3=a3[nomask]
    a4=a4[nomask]
    a5=a5[nomask]
    a6=2.*a5
    spec=spec[nomask] 
    diff=diff[nomask]
    counttime=counttime[nomask] 
    monitor=monitor[nomask]
endif

if n_elements(a4_mask) eq 2 then begin
    nomask=where( (a4 lt a4_mask[0]) or (a4 gt a4_mask[1]))
    a1=a1[nomask]
    a2=a2[nomask]
    a3=a3[nomask]
    a4=a4[nomask]
    a5=a5[nomask]
    a6=2.*a5
    spec=spec[nomask] 
    diff=diff[nomask]
    counttime=counttime[nomask] 
    monitor=monitor[nomask]
endif


end;MACS_get_a12345_int

