;
; Calculate R(Q,Y) as FT of R(Q,s)
;
function gen_rqy, y, Q, bValues
compile_opt idl2

if (n_params() ne 3) then return, 0

muPtr = ptr_new({b3:bValues[0]/Q,b5:bValues[1]/Q^3,b6:bValues[2]/Q^2})

; calculate function
Sq = 1.0
n = n_elements(y)
res = dblarr(n)
for i=0,n-1 do begin
  etc = {y:y[i],Q:Q,muPtr:muPtr}
  res[i] = Sq/!pi * qpint1d('rqys',0.0D,!values.d_infinity,functargs=etc, $
                             status=status,nfev=nfev)
endfor

return, res
end
